:- module(bdds,[
		bdd_and/3,
		bdd_entailed/2,
		bdd_finish/0,
		bdd_iff/3,
		bdd_implies/3,
		bdd_maximum/1,
		bdd_or/3,
		bdd_print/1,	
		bdd_down/2,
		bdd_rename/3,
                bdd_tagging/2,
                bdd_rename_apart/4,
		bdd_restrict/3,
		bdd_reverse_rename/3,
		bdd_proj_onto_exists/3,
		bdd_start/0,
		bdd_true/1,
		bdd_false/1,
                bdd_variable/2
	       ]).

bdd_entailed(Form, Var) :- 
	bdd_entailed(Form, Var, 1).

foreign(bdd_maximum,             bdd_maximum([-integer])).
foreign(bdd_rename,              bdd_rename(+integer, +term, [-integer])).
foreign(bdd_tagging,              bdd_tagging(+integer, [-integer])).
foreign(bdd_rename_apart,      bdd_rename_apart(+integer,+integer,+integer, [-integer])).
foreign(bdd_reverse_rename,      bdd_reverse_rename(+integer, +term, [-integer])).
foreign(bdd_proj_onto_exists,      bdd_proj_onto_exists(+integer, +term, [-integer])).
foreign(bdd_iff_conj_list,       bdd_iff(+integer, +term, [-integer])).
foreign(bdd_print,               bdd_print(+integer)).
foreign(bdd_print_dot,           bdd_print_dot(+string, +integer)).
foreign(bdd_and,                 bdd_and(+integer, +integer, [-integer])).
foreign(bdd_and_list,            bdd_and_list(+term, [-integer])).

foreign(bdd_down,                  bdd_down(+integer, [-integer])).
foreign(bdd_or,                  bdd_or(+integer, +integer, [-integer])).
foreign(bdd_implies,             bdd_implies(+integer, +integer, [-integer])).

foreign(bdd_abstract_unify_list, bdd_abstract_unify_list(+integer, +integer, +term, +integer, [-integer])).
foreign(bdd_abstract_exit_term,  bdd_abstract_exit_term(+integer, +integer, +term, +integer, [-integer])).

foreign(initRep,                bdd_start).
foreign(concludeRep,            bdd_finish).

foreign(bdd_entailed, 		bdd_entailed(+integer, +integer, [-integer])).
foreign(bdd_restrict, 		bdd_restrict(+integer, +integer, [-integer])).
foreign(bdd_restrict_var,       bdd_restrict_var(+integer, +integer, [-integer])).

foreign(bdd_variable,           bdd_variable(+integer, [-integer])).
foreign(bdd_false,              bdd_false([-integer])).
foreign(bdd_true,               bdd_true([-integer])).



foreign_resource(bdds, [
			bdd_rename, 
                        bdd_tagging,
                        bdd_rename_apart,
			bdd_maximum,
			bdd_reverse_rename, 
			bdd_proj_onto_exists, 
			bdd_iff_conj_list, 
			bdd_print,
			bdd_print_dot,
			bdd_and,
			bdd_and_list,
			bdd_or,
			bdd_down,
			bdd_implies,
			initRep,
			concludeRep,
			bdd_restrict_var,
			bdd_entailed,
			bdd_restrict,
			bdd_variable,
			bdd_true,
			bdd_false
		       ]).



:- load_foreign_resource(bdds).









