:- module(counter, [
                    enable_counting/0,
                    disable_counting/0,
                    reset_all_counters/0,
                    reset_counter/1,
                    inc_counter/1,
		    add_counter/2,
                    read_counter/2,
                    display_all_counters/0
                    ]).

:- dynamic '$counter'/2.

:- dynamic '$counting'/1.

'$counting'(true).

disable_counting :-
    ( retract('$counting'(_)) ; true ),
    assert('$counting'(false)).

enable_counting :-
    ( retract('$counting'(_)) ; true ),
    assert('$counting'(true)).


reset_all_counters   :-
    ( retract('$counter'(_,_)), fail ; true ).




/*

reset_all_counters     :- 
    reset_counter(bot(group)),
    reset_counter(bipai(group)),
    reset_counter(ext(group)),
    reset_counter(ident(group)),
    reset_counter(join(group)),
    reset_counter(leq(group)),
    reset_counter(meet(group)),
    reset_counter(top(group)),
    reset_counter(unify(group)),
    
    reset_counter(bot(pair)),
    reset_counter(bipai(pair)),
    reset_counter(ext(pair)),
    reset_counter(ident(pair)),
    reset_counter(join(pair)),
    reset_counter(leq(pair)),
    reset_counter(meet(pair)),
    reset_counter(top(pair)),
    reset_counter(unify(pair)),

    reset_counter(bot(mode2)),
    reset_counter(bipai(mode2)),
    reset_counter(ext(mode2)),
    reset_counter(ident(mode2)),
    reset_counter(join(mode2)),
    reset_counter(leq(mode2)),
    reset_counter(meet(mode2)),
    reset_counter(top(mode2)),
    reset_counter(unify(mode2)),

    reset_counter(red(pair,mode2)),
    reset_counter(red(pair,group)).
*/    
    
display_all_counters :-
    ( bagof((CName=CNum),'$counter'(CName,CNum),Pairs) -> true ; Pairs = [] ),
    sort(Pairs,PairsSorted),
    write('Numbers of operations:'),nl,
    list_display(PairsSorted),
    nl.

list_display([]).
list_display([H|L]) :-
    write(H),nl,
    list_display(L).
    
reset_counter(COUNTER_NAME) :-
    ( retract('$counter'(COUNTER_NAME,_COUNTER_NUM)) ; true ),
    assert('$counter'(COUNTER_NAME,0)).


inc_counter(COUNTER_NAME) :-
    (
        '$counting'(true)
    ->
        inc_counter_1(COUNTER_NAME)
    ;
        true
    ).

inc_counter_1(COUNTER_NAME) :-
    (
         retract('$counter'(COUNTER_NAME,COUNTER_NUM))
    ->
         NEW_COUNTER_NUM is COUNTER_NUM+1,
         assert('$counter'(COUNTER_NAME,NEW_COUNTER_NUM))
    ;
%         write('The counter '),
%         write(COUNTER_NAME),
%         write(' has been created and set to 1.'), nl,
         assert('$counter'(COUNTER_NAME,1))
     ).

read_counter(COUNTER_NAME,COUNTER_NUM) :-
    (
         '$counter'(COUNTER_NAME,COUNTER_NUM)
    ->
         true
    ;
         write('The counter '),
         write(COUNTER_NAME),
         write(' does not exists. Default value 0 is returned.'),nl,
         COUNTER_NUM is 0
     ).

add_counter(COUNTER_NAME,DIFF) :-
    (
        '$counting'(true)
    ->
        add_counter_1(COUNTER_NAME,DIFF)
    ;
        true
    ).

add_counter_1(COUNTER_NAME,DIFF) :-
    (
         retract('$counter'(COUNTER_NAME,COUNTER_NUM))
    ->
         NEW_COUNTER_NUM is COUNTER_NUM+DIFF,
         assert('$counter'(COUNTER_NAME,NEW_COUNTER_NUM))
    ;
%         write('The counter '),
%         write(COUNTER_NAME),
%         write(' has been created and set to '),
%         write(DIFF), write('.'), nl,
         assert('$counter'(COUNTER_NAME,DIFF))
     ).
