%% Sicstus Prolog

:- module(sys_dep, [
		    fileerrors/2,
                    free_variables/2,
		    index/1,
                    merge/3,
		    subset/2,
		    intersection/3,
                    string/1]).

:- [library(lists)].



/** Obsolescent. concate(+Atom1,+Atom2,-Atom3) iff Atom3 is Atom1
   appended with Atom2. 

concat(A1,A2,A3) :- 
    ( (ground(A1); ground(L1) ) -> name(A1,L1) ; true), 
    ( (ground(A2); ground(L2) ) -> name(A2,L2) ; true), 
    ( (ground(A3); ground(L3) ) -> name(A3,L3) ; true), 
    append(L1,L2,L3),
    ( (ground(A1); ground(L1) ) -> name(A1,L1) ; true), 
    ( (ground(A2); ground(L2) ) -> name(A2,L2) ; true), 
    ( (ground(A3); ground(L3) ) -> name(A3,L3) ; true).
*/


/* fileerrors(-Old,+New) turns on/off file error flag and change file
   error behaviour */

fileerrors(Old,New) :- prolog_flag(fileerrors,Old,New).


/** Obsolescent. style_check(+/-option) change style check
   behaviour. SWI Prolog defines style-check/1 for various options. We
   only define it for +/-singleton. */

style_check(+singleton) :- prolog_flag(single_var_warnings,_,on).
style_check(-singleton) :- prolog_flag(single_var_warnings,_,off).

/* index(+Spec) Sicstus doesn't allow the user to give indexing
   specifications. It is simply ignored in current implementation. */

index(_).


:- use_module(library(terms)). 

free_variables(Term,Vs) :- 
   term_variables(Term,Vs0), 
   sort(Vs0,Vs).

/* free_variables(+Term,-Vs) Vs is the set of free variables in Term.

free_variables(Term,Vs) :- 
    free_variables(Term,[],Vs0),
    sort(Vs0,Vs).

free_variables(X,Vs,[X|Vs]) :- 
    var(X),
    !.
free_variables(Term,Vs0,Vs) :-
    Term =.. [_|Terms],
    free_variables_in_terms(Terms,Vs0,Vs).

free_variables_in_terms([],Vs,Vs).
free_variables_in_terms([Term|Terms],Vs0,Vs) :-
    free_variables(Term,Vs0,Vs1),
    free_variables_in_terms(Terms,Vs1,Vs).
*/
 
string(_) :- !,fail.


merge([], Y, Y).
merge(X, [], X).
merge([H|X], [E|Y], [H|Z]) :- H @< E,  merge(X, [E|Y], Z).
merge([H|X], [E|Y], [E|Z]) :- H @>= E, merge([H|X], Y, Z).

subset([],_).
subset([H|L1],L2) :- 
    member(H,L2), 
    !,
    subset(L1,L2). 

intersection([],_,[]).
intersection([H|L1],L2,[H|L3]) :- 
    member(H,L2), 
    !,
    intersection(L1,L2,L3). 
intersection([_H|L1],L2,L3) :- 
%   \+  member(H,L2), 
    intersection(L1,L2,L3). 



