:- use_module(asem,	[
                asem_bu/6,
                asem_display/2]
	).

testall(File) :-
        open(File,read,Stream),
        % stripping of prefix "script_"
        atom_concat('script_',Log0,File),
        atom_concat('result_bu_',Log0,Log),
        retractall(total_time(_)), assert(total_time(0)),
        testall_1(Stream,Log),
        close(Stream),
        current_output(Screen),
        open(Log,append,Disk),
        set_output(Disk),
        total_time(Time),
        write(total_time(Time)), nl 
        ,close(Disk)
        ,set_output(Screen)
        .

testall_1(Stream,Log) :-
        read_term(Stream,Term,[]),
        (
                Term = end_of_file
        ->
                true
        ;
                Term =.. [test,Prog,Name,Alpha|_]
        ->      
                testone(Prog,Name,Log,Alpha),
                testall_1(Stream,Log)
        ;
                write(Term), 
                write(' is not a valid analysis specification!'), 
                nl
        ).



		
testone(Prog,Name,Log,Alpha)	:-
    asem_bu(Alpha,Prog,Tinit,Tbu,Lines,Pids), T is Tinit+Tbu, 
    ( Pids=[] -> true ; write('Undefined: '),write(Pids), nl),
    write('prog('), writeq(Name), write(','), write(Lines), write(','),
    write_num(T), write('='), 
    write_num(Tinit), write('+'), 
    write_num(Tbu), write(').'), nl,
    asem_display(Alpha,answer),nl,nl,
    current_output(Screen),
    open(Log,append,Disk),
    set_output(Disk), 
    write('prog('), writeq(Name), write(','), write(Lines), write(','),
    write_num(T), write('='), 
    write_num(Tinit), write('+'), 
    write_num(Tbu), write(').'), nl,
    close(Disk),
    set_output(Screen),
    retract(total_time(OldTotal)), 
    NewTotal is OldTotal+T, 
    assert(total_time(NewTotal)),
    !.


write_num(N) :- integer(N),!, write(N).

write_num(N) :- prolog_flag(language,Old,iso),
                I is floor(N), 
                write(I), 
                write('.'),
                F is N-I, 
                write_frac(F),
                prolog_flag(language,_,Old).

write_frac(F) :- F1 is F*10, 
    D1 is floor(F1), Co1 is D1+ 48, 
    F2 is (F1-D1)*10, 
    D2 is floor(F2),Co2 is D2+ 48,
    F3 is (F2-D2)*10,
    D3 is floor(F3), Co3 is D3+ 48,
    put_code(Co1),put_code(Co2),put_code(Co3).
                 
