:- use_module(asem,	[asem_bw/8,asem_display/2] ).

testall(File) :-
        open(File,read,Stream),
        retractall(total_time(_)), assert(total_time(0)),
        atom_concat('script_',File1,File),
        atom_concat('res_bw_',File1,Log),
        testall_1(Stream,Log),
        close(Stream),
        total_time(Time),
        current_output(Screen),
        open(Log,append,Disk),
        set_output(Disk),
        write(total_time(Time)), write('.'), nl,
	close(Disk),
        set_output(Screen),
        write(total_time(Time)), write('.'), nl.

testall_1(Stream,Log) :-
        read_term(Stream,Term,[]),
        (
                Term = end_of_file
        ->
                true
        ;
	       ( Term = test(Prog,Name,Alpha) ; Term = test(Prog,Alpha), Prog=Name )
        ->      
                testone(Prog,Name,Log,Alpha),
                testall_1(Stream,Log)
        ;
                write(Term), 
                write(' is not a valid analysis specification!'), 
                nl
        ).



		
testone(Prog,Name,Log,Alpha)	:-
    asem_bw(Alpha,Prog,T1,T2,T3,T4,Lines,Pids), T is T1+T2+T3+T4,
    asem_display(Alpha,demand),
    current_output(Screen),
    open(Log,append,Disk),
    set_output(Disk),
        (Pids =[] -> true ; write('Undefined: '),write(Pids), nl),
    write('prog('), writeq(Name), write(','), write(Lines), write(','),
    write_num(T), write('='), 
    write_num(T1), write('+'), 
    write_num(T2), write('+'), 
    write_num(T3), write('+'), 
    write_num(T4), write(').'), nl,
    close(Disk),
    set_output(Screen),
        (Pids =[] -> true ; write('Undefined: '),write(Pids), nl),
    write('prog('), writeq(Name), write(','), write(Lines), write(','),
    write_num(T), write('='), 
    write_num(T1), write('+'), 
    write_num(T2), write('+'), 
    write_num(T3), write('+'), 
    write_num(T4), write(').'), nl,
        retract(total_time(OldTotal)), 
        NewTotal is OldTotal+T, 
        assert(total_time(NewTotal)),
	!.


write_num(N) :- integer(N),!,write(N).
write_num(N) :- prolog_flag(language,Old,iso),
                I is floor(N), 
                write(I), 
                write('.'),
                F is N-I, 
                write_frac(F),
                prolog_flag(language,_,Old).

write_frac(F) :- F1 is F*10, 
    D1 is floor(F1), Co1 is D1+ 48, 
    F2 is (F1-D1)*10, 
    D2 is floor(F2),Co2 is D2+ 48,
    F3 is (F2-D2)*10,
    D3 is floor(F3), Co3 is D3+ 48,
    put_code(Co1),put_code(Co2),put_code(Co3).
                 
