:- use_module(asem,	[
                asem_td/7,
                asem_display/2]
	).

:- use_module('Domain/basics.pl',   [
		vars/2,
                intern/3,
                sub_apply/3]
        ).

:- use_module('Domain/counter.pl'). 


testall(File) :-
    open(File,read,Stream),
        % stripping of prefix "script_"
    ( atom_concat('script_',Log0,File) -> true ; Log0=File ),
    ( atom_concat(Log1,'.pl',Log0) -> true ; Log1=Log0 ),
    atom_concat('result_td_',Log1,Log),
    retractall(total_time(_)), assert(total_time(0)),
    retractall(total_checking_time(_)), assert(total_checking_time(0)),
    testall_1(Stream,Log),
    close(Stream),
    total_time(Time), total_checking_time(TimeChk),
    current_output(Screen),
    open(Log,append,Disk),
    set_output(Disk),
    write(total_time(Time)), nl, 
    write(total_checking_time(TimeChk)), nl, 
    close(Disk),
    set_output(Screen),
    write(total_checking_time(TimeChk)), nl, 
    write(total_time(Time)), nl.

testall_1(Stream,Log) :-
        read_term(Stream,Term,[variable_names(NL)]),
        (
                Term = end_of_file
        ->
                true
        ;
	      ( 
                Term = test(Prog,Name,Alpha,ASub,Goal,Tab)
              ;
                Term = test(Prog,Alpha,ASub,Goal,Tab),Name = Prog
	      ;
	        Term = test(Prog,Alpha,ASub,Goal),
	        Name = Prog,
	        nl_to_tab(NL,Tab)
              )
          
        ->      
                testone(Prog,Name,Alpha,ASub,Goal,Tab,Log), !, 
                testall_1(Stream,Log)
        ;
                write(Term), 
                write(' is not a valid analysis specification!'), 
                nl
        ).

testone(Prog,Name,Alpha,INx,GoalX,TabX,Log)	:-
    reset_all_counters,
    intern((INx,GoalX,TabX),(IN,Goal,Tab),_),
    asem_td(Alpha,Prog,(Goal,IN,Tab),InitLapse,TDLapse,Lines,Pids), 
    Lapse is InitLapse+TDLapse,
    (Pids=[] -> true ; write('Undefined: '),write(Pids), nl),
    sub_apply(Tab,Goal,GoalO),
    sub_apply(Tab,IN,InO),
    write('>> '), 
    writeq(prog(Name,Alpha,Lines,InO,GoalO,Lapse=InitLapse+TDLapse)), nl,nl,
%    asem_display(Alpha,answer),nl,nl,
%    display_all_counters,!,
    current_output(Screen),
    open(Log,append,Disk),
    set_output(Disk),
    writeq(prog(Name,Alpha,Lines,InO,GoalO,Lapse=InitLapse+TDLapse)), 
    write('.'), nl,nl,
    asem_display(Alpha,answer),nl,nl,
    display_all_counters,
    read_counter('checking_time',ChkTime),
    close(Disk),
    set_output(Screen),
    retract(total_checking_time(OldTime)),
    NewTime is OldTime+ChkTime,
    assert(total_checking_time(NewTime)),
    retract(total_time(OldTotal)), 
    NewTotal is OldTotal+Lapse, 
    assert(total_time(NewTotal)),
    !.


:- dynamic total_time/1,total_checking_time/1. 


nl_to_tab([],[]).
nl_to_tab([Name=Var|Xs],[Var/Name|Tab]) :- 
    nl_to_tab(Xs,Tab).



%:- testall(script_rtype).



