
partition([X|T],P,[X|B],A) :-
    X =< P,
    partition(T,P,B,A).

partition([X|T],P,B,[X|A]) :-
    X > P,
    partition(T,P,B,A).

partition([],_,[],[]).


/* Improved Quicksort using stacks */

iqsort(L,R) :- iqsort_aux(L,[],R).

iqsort_aux([X|T],S,R) :-
     partition(T,X,B,A),
     iqsort_aux(A,S,Sn),
     iqsort_aux(B,[X|Sn],R).
iqsort_aux([],S,S).


:- type nat ::= 0 ; s(nat).
%:- type list(A) ::= [] ; [A|list(A)].





