/* From the  book PROLOG PROGRAMMING IN DEPTH by Michael A. Covington,
Donald Nute, and Andre Vellino.   Copyright 1988 Scott, Foresman & Co.
Non-commercial distribution of this file is permitted. */

/* sorting a list by converting it into  a binary tree, then back into
a list */

treesort(Li,Lo) :-
	list_to_tree(Li,T),
        tree_to_list(T,Lo).

/* insert(Ele,Tree,NewTree) inserts Ele into Tree giving NewTree. */

insert(I,void,tr(I,void,void)) :- number(I).
insert(I,tr(E,L,R),tr(E,Ln,R)) :-
     	I < E,
     	insert(I,L,Ln).

insert(I,tr(E,L,R),tr(E,L,Rn)) :-
     	I >= E,
     	insert(I,R,Rn).

/*  insert_list(List,Tree,NewTree) inserts all elements  of  List into
Tree giving NewTree.  */

insert_list([H|L],T,Tn) :-
     	insert(H,T,Tm),
     	insert_list(L,Tm,Tn).
insert_list([],T,T).

/*  list_to_tree(List,Tree)  inserts all  elements  of  List  into  an
initially void tree.  */

list_to_tree(L,T) :- insert_list(L,void,T).

/* tree_to_list(Tree,List)  places all elements of  Tree  into List in
sorted order.  */

tree_to_list(T,L) :-
     	tree_to_list_aux(T,[],L).

tree_to_list_aux(void,L,L).
tree_to_list_aux(tr(I,L,R),O,N) :-
     	tree_to_list_aux(R,O,L1),
     	tree_to_list_aux(L,[I|L1],N).

% covington-2

:- type nat ::= 0 ; s(nat).
%:- type list(A) ::= [] ; [A|list(A)].
:- type tree(B) ::= void ; tr(B,tree(B),tree(B)).




