% run this program, test cases will be taken from script_rtype and 
%                   data will be collected in time.data

:- use_module(asem,	
	      [asem_td/7,
	       asem_display/2]
	).

:- use_module('Domain/basics.pl',
	      [vars/2,
	       intern/3,
	       sub_apply/3]
        ).

:- use_module('Domain/counter.pl'). 


testall(File) :-
    open(File,read,Stream),
    Log = 'dtype.data',
    retractall(total_time(_)), assert(total_time(0)),
    testall_1(Stream,Log),
    close(Stream),
    total_time(Time),
    current_output(Screen),
    open(Log,append,Disk),
    set_output(Disk),
    write(total_time(Time)), write('.'), nl, 
    close(Disk),
    set_output(Screen),
    write(total_time(Time)), nl.

testall_1(Stream,Log) :-
        read_term(Stream,Term,[]),
        (
                Term = end_of_file
        ->
                true
        ;
	      ( 
                Term = test(Prog,Name,rtype,[ASub],Goal,Tab)
              ;
                Term = test(Prog,rtype,[ASub],Goal,Tab),Name = Prog
	      ;
	        Term = test(Prog,rtype,[ASub],Goal),
	        Name = Prog,
	        free_variables((ASub,Goal),Vs),
	        identity_symbol_tab(Vs,Tab)
              )
          
        ->      
                testone(Prog,Name,monotype,ASub,Goal,Tab,Log), !, 
                testall_1(Stream,Log)
	 ;
                write(Term), 
	        write(' is not a valid analysis specification!'), 
                nl
        ).

testone(Prog,Name,Alpha,INx,GoalX,TabX,Log)	:-
        reset_all_counters,
	intern((INx,GoalX,TabX),(IN,Goal,Tab),_),
        asem_td(Alpha,Prog,(Goal,IN,Tab),InitLapse,TDLapse,Lines,Pids), 
        Lapse is InitLapse+TDLapse,
        ( Pids \= [] -> write('Undefined: '),write(Pids), nl ; true ),
        sub_apply(Tab,Goal,GoalO),
        sub_apply(Tab,IN,InO),
        write('>> '), 
        writeq(prog(Name,Alpha,Lines,InO,GoalO,Lapse)), nl,nl,
        asem_display(Alpha,answer),nl,nl,
        display_all_counters,!,
        current_output(Screen),
        open(Log,append,Disk),
        set_output(Disk),
        writeq(prog(Name,Alpha,Lines,InO,GoalO,Lapse)), 
        write('.'), nl,
        asem_display(Alpha,answer),nl,nl, %%%
        close(Disk),
        set_output(Screen),
        retract(total_time(OldTotal)), 
        NewTotal is OldTotal+Lapse, 
        assert(total_time(NewTotal)),
	!.


:- dynamic total_time/1. 


identity_symbol_tab([],[]).
identity_symbol_tab([X|Xs],[X/X|Tab]) :- 
    identity_symbol_tab(Xs,Tab).


:- testall(script_rtype_tplp).
